#include <stdio.h>

#define SIZE 100000 //Must be divisible by 10
#define AVGTIMES 10000 //Number of times to call each function

void down()
{
unsigned int sum=0;
unsigned int ii;

for(ii=SIZE;ii>0;ii--)
   {
   sum += ii;
   }
}

void unrolleddown()
{
unsigned int sum=0;
unsigned int ii;

for(ii=SIZE;ii>0; )
   {
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   sum += ii--;
   }
}

void unrolledup()
{
unsigned int sum=0;
unsigned int ii;

for(ii=1;ii<=SIZE; )
   {
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   sum += ii++;
   }
}

void up()
{
unsigned int sum=0;
unsigned int ii;

for(ii=1;ii<=SIZE; ii++)
   {
   sum += ii;
   }
}

void crazy()
{
unsigned int sum=0;
unsigned int bot=0;
unsigned int top=0;

unsigned int ii;
unsigned int jj;

for(ii=1,jj=SIZE/2+1;ii<=SIZE/2; )
   {
   bot += ii++;
   top += jj++;
   bot += ii++;
   top += jj++;
   bot += ii++;
   top += jj++;
   bot += ii++;
   top += jj++;
   bot += ii++;
   top += jj++;
   }
sum = bot+top;
}

__int64 __declspec(naked) TimeIt(void f())
{
	__asm {
	      rdtsc
	      push	edx
	      push	eax
	      call	[esp+12]
	      rdtsc
	      pop	ecx
	      sub	eax, ecx
	      pop	ecx
	      sbb	edx, ecx
	      ret
	}
}

void all()
{
double sum=0;
int ii;

for(sum=ii=0;ii<AVGTIMES;ii++) sum += TimeIt(up);
printf("Avg. clock cycles: up           %g\n",sum/AVGTIMES/SIZE);

for(sum=ii=0;ii<AVGTIMES;ii++) sum += TimeIt(down);
printf("Avg. clock cycles: down         %g\n",sum/AVGTIMES/SIZE);

for(sum=ii=0;ii<AVGTIMES;ii++) sum += TimeIt(unrolledup);
printf("Avg. clock cycles: unrolledup   %g\n",sum/AVGTIMES/SIZE);

for(sum=ii=0;ii<AVGTIMES;ii++) sum += TimeIt(unrolleddown);
printf("Avg. clock cycles: unrolleddown %g\n",sum/AVGTIMES/SIZE);

for(sum=ii=0;ii<AVGTIMES;ii++) sum += TimeIt(crazy);
printf("Avg. clock cycles: crazy        %g\n",sum/AVGTIMES/SIZE);
}

int main()
{

printf ("Total of %f clock megacycles\n",TimeIt(all)/1000.0);
return 0;
}
